/*
 * massive_occlusionpass.sl - all-in-one ambient occlusion pass for Massive
 *
 * HISTORY
 *
 *   Jul-25-2007:  added maxerror parm and maxpixeldist to occlusion()
 *
 *   Feb-05-2007:  added samples, maxhitdist, bias parameters for
                  Massive version

 *  (c) 2007 SiTex Graphics, Inc.
 */

surface massive_occlusionpass(
   float invert = 0;

   float samples = 256;
   float maxhitdist = 500;
   float maxerror = 0.0;

   float shadowbias = 0.1;
   float coneangle = 1.57;

   string shadowgroups = "";

   output varying normal Nunoccl = 0;
  )
{
  normal Nf;
  color o;

  Nf = faceforward(normalize(N), I);

  if (shadowgroups!="")
    o = occlusion (P, Nf, coneangle, Nunoccl, "samples", samples, "maxhitdist", maxhitdist,
                   "maxerror", maxerror, "bias", shadowbias, "maxpixeldist", 0, "subset", shadowgroups);

  else
    o = occlusion (P, Nf, coneangle, Nunoccl, "samples", samples, "maxhitdist", maxhitdist,
                   "maxerror", maxerror, "bias", shadowbias, "maxpixeldist", 0);

  if (invert==1) o=1-o;

  Oi = Os;
  Ci = Oi * o;
}

